﻿package org.highangle.ui.DisplayObjectTable
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setTimeout;
	//import com.eiyo.shokudo.ui.ItemContainer;
	
	/**
	 * ...
	 * @author test
	 */
	public class DisplayObjectTable extends Sprite 
	{
		private var List:Array;
		private var padding:Number = 5;
		private var captureObj:Sprite = new Sprite();
		private var _row:int;
		private var _col:int;
		private var _selected:Point = new Point();
		private var _destination:Point = new Point();
		
		private var defaultRow:Number = 100;
		private var defaultCol:Number = 100;
		private var selectItem:ItemContainer;
		
		public function DisplayObjectTable(row:int, col:int, cellWidth:int = 0, cellHeight:int = 0):void 
		{
			_row = row;
			_col = col;
			
			defaultRow = cellWidth ? cellWidth : defaultRow;
			defaultCol = cellHeight ? cellHeight : defaultCol;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			List = new Array(_row);
			for (var i:int = 0; i < List.length; i++) 
			{
				List[i] = new Array(_col);
				for (var s:int = 0; s < List[i].length; s++) 
				{
					var trgt:ItemContainer = new ItemContainer(i,s, defaultRow, defaultCol);
					List[i][s] = trgt;
					
					trgt.x = (defaultRow + padding) * i + padding; 
					trgt.y = (defaultCol + padding) * s + padding;
					trgt.addEventListener(MouseEvent.MOUSE_DOWN, onDownChild);
					trgt.addEventListener(MouseEvent.MOUSE_UP, onUpChild);
					addChild(trgt);
				}
			}
		}
		
		public function update():void
		{
			for (var i:int = 0; i < List.length; i++) 
			{
				for (var s:int = 0; s < List[i].length; s++) 
				{
					List[i][s].x = (defaultRow + padding) * i + padding; 
					List[i][s].y = (defaultCol + padding) * s + padding;
					List[i][s].row = i;
					List[i][s].col = s;
					List[i][s].update();
				}
			}
		}
		
		public function add(row:int, col:int, tr:DisplayObject):void
		{
			List[row][col].add(tr);
		}
		
		public function onDownChild(e:MouseEvent):void
		{
			if (selectItem)
			{
				selectItem.select(false);
			}
			
			selectItem = (e.currentTarget as ItemContainer);
			selectItem.select(true);
			_selected.x = selectItem.row;
			_selected.y = selectItem.col;
			
			if (! selectItem.move)
			{
				return;
			}
			
			var bmd:BitmapData = new BitmapData(defaultRow, defaultCol, true, 0);
			bmd.draw(e.currentTarget as DisplayObject);
			var bm:Bitmap = new Bitmap(bmd);
			
			captureObj.addChild(bm);
			captureObj.x = mouseX - e.localX;
			captureObj.y = mouseY - e.localY;
			captureObj.alpha = 0.4;
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			captureObj.mouseEnabled = false;
			captureObj.startDrag();
			addChild(captureObj);
			
			function onMouseUp(e:MouseEvent):void
			{
				stage.removeEventListener(MouseEvent.MOUSE_UP, arguments.callee);
				captureObj.stopDrag();
				bm.bitmapData.dispose();
				captureObj.removeChild(bm);
				bm = null;
				removeChild(captureObj);
				//selectItem = null;
			}
			
		}
		
		public function onUpChild(e:MouseEvent):void
		{
			var e2:Event;
			switch(true)
			{
				case (! selectItem):
				case (selectItem == e.currentTarget):
				//case (!selectItem.move):
				case (! e.currentTarget.move):
				{
					e2 = new Event(Event.SELECT);
					dispatchEvent(e2);
					e2 = null;
					return;
				}
				
			}
			_destination.x = e.currentTarget.row;
			_destination.y = e.currentTarget.col;
			
			List[selectItem.row][selectItem.col] = e.currentTarget;
			List[_destination.x][_destination.y] = selectItem;
			
			e2 = new Event(Event.CHANGE);
			dispatchEvent(e2);
			e2 = null;
			
			update();
			selectItem.select(false);
			selectItem = null;
		}
		
		public function get selected():Point 
		{
			return _selected;
		}
		
		public function get destination():Point 
		{
			return _destination;
		}
		
		
		
		
	}
	
}