package org.highangle.ui.DisplayObjectTable
{
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.JointStyle;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.geom.ColorTransform;
	//import com.eiyo.shokudo.ui.DisplayObjectTable;
	/**
	 * ...
	 * @author test
	 */
	public class ItemContainer extends Sprite 
	{
		private var Mask:Sprite;
		private var defaultRow:Number = 100;
		private var defaultCol:Number = 100;
		
		public var container:Sprite;
		public var content:DisplayObject;
		public var row:int;
		public var col:int;
		public var move:Boolean = true;
		
		public function ItemContainer(r:int, c:int, w:int, h:int):void 
		{
			row = r;
			col = c;
			defaultRow = w;
			defaultCol = h;
			
			container = new Sprite();
			Mask = new Sprite();
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			update();
			addEventListener(MouseEvent.ROLL_OVER, onOver);
			addEventListener(MouseEvent.ROLL_OUT, onOut);
			
		}
		
		public function update():void
		{
			var g:Graphics = container.graphics;
			g.clear();
			g.beginFill(0xcccccc);
			g.drawRect(0, 0, defaultRow , defaultCol);
			g.endFill();
			if (container.parent)
			{
				removeChild(container);
			}
			addChild(container);
			
			g = Mask.graphics;
			g.clear();
			g.beginFill(0x00ff00, 0.2)
			g.drawRoundRect(0, 0, defaultRow , defaultCol, 
				(defaultRow + defaultCol) * 0.1 );
			g.endFill();
			if (Mask.parent)
			{
				container.removeChild(Mask);
			}
			container.addChild(Mask);
			container.mask = Mask;
		}
		
		private function onOver(e:MouseEvent):void 
		{
			filters = [new GlowFilter(0x70b0ff)];
		}
		
		private function onOut(e:MouseEvent):void 
		{
			filters = null;
		}
		
		public function select(flg:Boolean):void
		{
			if (flg)
			{
				transform.colorTransform = getColor(0x6699ff, 0.4);
			}
			else
			{
				transform.colorTransform = getColor(0, 0);
			}
			
		}
		/*
		private function onDown(e:Event):void
		{
			//startDrag();
		}
		*/
		
		private function getColor( color:int, percent:Number = 1 ):ColorTransform 
		{
			var k:Number = 1.0 - percent;
			var red:Number = (color >> 16 & 0xFF) * percent;
			var green:Number = (color >> 8 & 0xFF) * percent;
			var blue:Number = (color & 0xFF) * percent;
			
			return new ColorTransform( k, k, k, 1, red, green, blue );
		}
		
		public function add(tr:DisplayObject):void
		{
			content = tr;
			container.addChild(content);
		}
		
		public function setParam(ob:Object):void
		{
			for (var i:String in ob)
			{
				switch(i)
				{
					case 'move':
					{
						move = (ob[i] is Boolean)? ob[i] : move;
						break;
					}
				}
			}
		}
		
		
		
	}
	
}